'''
Empires Mod API  Eventscripts Libary
Version: 0.10 Alpha
(C) [#OMEGA] - K2

IMPORTANT

This file is designed to be used with Empires 2.24d
Any other version might not work properly.

Agreement

By using this file you agree to the following terms:

This file is delivered 'as-is'. 
I will not take resposibilty for any damage resulting of the use or not-use of this file. 
You use this file with your own risk. 
You are allowed to share this file, but you do not have the permission to use any contents of this file in your own script, unless explitcy permitted.
You are not allowed to make profit with this file.
'''

# Plugin info (for later use)

plugindata = {"version": 0.10,
"state": "Alpha",
"building": True,
"tank": True,
"player": True,
"game": True}

# TODO
# Tank - add more/remaining stuff
# Support for "Add all functions" (mainly tank)
# SetAllArmorPLates/GetAllArmorPlates
#
# Player class - remaing functions, ammo etc
# Finish last 4 player class funcs
# Finish SetAmmo/GetAmmo
# Check descriptions for GetJumpTime,GetDuckJumpTime
#
# Change SetLocation accordingly
#
# New shared funcs such as int, intchk,etc
#
# Code op
#
# more data output funcs for the weapons, id, get descriptions etc
#
# Help class - improved
#
# Fake stuff starting with SetScore


# #### #
# Imports #
# #### #

# Python Imports
import random
import pydoc

# ES Libary Imports
import es
import playerlib
import keyvalues

# Check for proper game
if 'empires' not in es.getgame().lower():
	raise Exception, 'Can\' load empires_api where empires is not running.'

# Set Public Info

es.set("empires_api_version","%.2f %s" % (plugindata["version"],plugindata["state"]))
es.makepublic("empires_api_version")

# #### #
# Classes #
# #### #

# Exceptions

class InputError(Exception):
	'''
	Let's raise some input errors :D
	'''
	pass
	
class UseridError(Exception):
	'''
	Another class for rasing errors.
	'''
	pass
	
class InitError(Exception):
	'''
	Used for rasing an error when a class hasn't been inited yet.
	'''
	pass
	
# Shared Classes

class __shared(object):
	'''
	Basic class for mapping(dict) and attribute support.
	'''
	__helpers = ['help','items','functions']
	def __getitem__(self,key):
		key = key.lower()
		if self.getitems.has_key(key):
			return self.getitems[key]()
		elif key in self.__helpers:
			es.dbgmsg(0,'Printing possible items for value retrival:')
			for item in self.getitems:
				es.dbgmsg(0,item)
			return True
		else:
			raise KeyError,'The specified key does not exist.\nKey was: %s' % key
	def __setitem__(self,key,value):
		key = key.lower()
		if self.setitems.has_key(key):
			return self.setitems[key](value)
		elif key in self.__helpers:
			es.dbgmsg(0,'Printing possible items for value setting:')
			for item in self.setitems:
				es.dbgmsg(0,item)
		else:
			raise KeyError,'The specified key does not exist.\nKey was: %s' % key

class __entshared(__shared):
	'''
	Used in several classes... mainly provides CBaseEntity Wrappers.
	'''
	def __init__(self):
		self.getitems['location'] = self.GetLocation
		self.getitems['locationstring'] = self.GetLocationString
		self.setitems['location'] = self.SetLocation
		self.setitems['locationstring'] = self.SetLocationString
		self.getitems['origin'] = self.GetOrigin
		self.getitems['originstring'] = self.GetOriginString
		self.setitems['origin'] = self.SetOrigin
		self.setitems['originstring'] = self.SetOriginString
	def GetLocation(self):
		'''
		Returns the location as x y z.
		'''
		return self.GetLocationString().split(',')
	def GetLocationString(self):
		'''
		Returns the location as string.
		'''
		return es.getindexprop(self.index,"CBaseEntity.m_vecOrigin")
	def SetLocation(self,x,y,z):
		'''
		Sets the lcoation as x y z.
		'''
		for var in x,y,z:
			if type(var) not in [float,int,long]:
				raise InputError,"Wrong input type. Input has to be numerical.\nInput type was %s" % type(var)
		es.setindexprop(self.index,"CBaseEntity.m_vecOrigin","%s,%s,%s" % (x,y,z))
	def SetLocationString(self,string):
		'''
		Sets the location as string.
		The string must consist of 3 cordinates.
		'''
		es.setindexprop(self.index,"CBaseEntity.m_vecOrigin",string)
	def GetOrigin(self):
		'''
		Returns the location as x y z.
		'''
		return self.GetOrigin()
	def GetOriginString(self):
		'''
		Returns the location as string.
		'''
		return self.GetOriginString()
	def SetOrigin(self,x,y,z):
		'''
		Sets the lcoation as x y z.
		'''
		self.SetLocation(x,y,z)
	def SetOriginString(self,string):
		'''
		Sets the location as string.
		The string must consist of 3 cordinates.
		'''
		self.SetLocationString(string)

# Main Classes

class building(__entshared):
	# # # # #
	# DATA #
	# # # # #
	getitems = {}
	setitems = {}
	
	index = None
	
	def __init__(self,index):
		self.index = index
		if plugindata['building']:
			# Dict/Attr Support
			super(building,self).__init__()
			# Get Items
			self.getitems['health'] = self.GetHealth
			self.getitems['maxhealth'] = self.GetMaxHealth
			self.getitems['isbuilt'] = self.IsBuilt
			self.getitems['built'] = self.IsBuilt
			self.getitems['issabotaged'] = self.IsSabotaged
			self.getitems['isfullysabotaged'] = self.IsFullySabotaged
			self.getitems['isbeingsabotaged'] = self.IsBeingSabotaged
			self.getitems['sabotageamount'] = self.GetSabotageAmount
			self.getitems['isbeingrecycled'] = self.IsBeingRecycled
			self.getitems['recycletime'] = self.GetRecycleTime
			#Set Items
			#self.setitems['health'] = self.SetHealth
			#self.setitems['maxhealth'] = self.SetMaxHealth
			self.setitems['built'] = self.SetBuiltState
			self.setitems['builtstate'] = self.SetBuiltState
			self.setitems['sabotagedstated'] = self.SetSabotagedState
			# Set data to false:
			plugindata['building'] = False
	# # # # # # # # #
	# Public functions #
	# # # # # # # # #
	"""
	Does not work.
	def SetMaxHealth(self,health):
		'''
		Sets the maximum health of the specified building. It can be repaired to the maximum only.
		'''
		es.setindexprop(index,'CEmpBuilding.m_iMaxHealth',health)
	"""
	def GetMaxHealth(self):
		'''
		Returns the maximum health of the specified building.
		'''
		return es.getindexprop(index,'CEmpBuilding.m_iMaxHealth')
	"""
	Does not work.
	def SetHealth(self,health):
		'''
		Sets the maximum health of the specified building.
		Avoid setting this higher then the building's maximum health as it may cause problems. 
		'''
		es.setindexprop(index,'CEmpBuilding.m_iHealth',health)
	"""
	def GetHealth(self):
		'''
		Returns the current health of the specified building.
		'''
		return es.getindexprop(index,'CEmpBuilding.m_iHealth')
	def IsBuilt(self):
		'''
		Returns True if the building is fully built.
		'''
		return __bool(es.getindexprop(index,'CEmpBuilding.m_bFullyBuilt'))
	def SetBuiltState(self,state):
		'''
		Sets the Built state of the specified building.
		0 = not built, 1 = built
		'''
		if state not in [0,1]:
			raise InputError, "Wrong Input value. State has to be 0 (not built) or 1 (bulit).\nInput was: %s" % state
		es.setindexprop(index,'CEmpBuilding.m_bFullyBuilt',state)
	def GetOwner(self):
		'''
		Returns the player index (NOT userid) of building's owner.
		'''
		return es.getindexprop(index,'CEmpBuilding.m_iOwner')
	# SettingsOwner does not work
	def IsSabotaged(self):
		'''
		Returns whether the building is (being) sabotaged.
		'''
		return __bool(es.getindexprop(index,'CEmpBuilding.m_bSabotaged'))
	def IsFullySabotaged(self):
		'''
		Returns whether the building is fully sabotaged.
		'''
		sab = self.IsSabotaged()
		if sab and self.GetSabotageAmount() == 0:
			return True
		return False
	def IsBeingSabotaged(self):
		'''
		Returns whether the building is being sabotaged.
		'''
		sab = self.IsSabotaged()
		if sab and self.GetSabotageAmount() != 0:
			return True
		return False
	def SetSabotagedState(self,state):
		'''
		Sets the Sabotaged state of the specified building.
		0 = not sabtoaged (resets the sabotage amount,too), 1 = sabotaged
		'''
		if state not in [0,1]:
			raise InputError, "Wrong Input value. State has to be 0 (not sabotaged) or 1 (sabotaged).\nInput was: %s" % state
		return es.setindexprop(index,'CEmpBuilding.m_bSabotaged',state)
	def GetSabotageAmount(self):
		'''
		Returns the amount how much the building is sabotaged (in decimal percent).
		Returns 0 if no sabotage is in process.
		'''
		return es.getindexprop(index,'CEmpBuilding.m_flSabotageTime')
	def IsBeingRecycled(self):
		'''
		Returns True if the specified building is being recycled, False otherwise.
		'''
		return __bool(es.getindexprop(index,'CEmpBuilding.m_bRecycling'))
	def GetRecycleTime(self):
		'''
		Returns the remaining time until the building is recycled.
		'''
		return es.getindexprop(index,'CEmpBuilding.m_iRecycleTime')
	
# Class for turrets with building as subclass
class turret(building):
	pass
	
class cap_point(__entshared):
	index = None
	def __init__(self,index):
		self.index = index

class player(__shared):
	'''
	Provides access to any player related stuff.
	'''
	# # # # #
	# DATA #
	# # # # #
	getitems = {}
	setitems = {}
	
	manager = {}
	
	userid = None

	weaponentitydata = {1: 'weapon_emp_nf_pistol',
	2: 'weapon_emp_nf_shot_pistol',
	3: 'weapon_emp_nf_smg1',
	4: 'weapon_emp_nf_smg2',
	5: 'weapon_emp_nf_smg3',
	6: 'weapon_emp_nf_rifle',
	7: 'weapon_emp_nf_scout_rifle',
	8: 'weapon_emp_nf_50cal',
	9: 'weapon_emp_nf_hmg',
	10: 'weapon_emp_nf_rpg',
	12: 'weapon_emp_nf_explosive_grenade',
	13: 'weapon_emp_nf_concussion_grenade',
	14: 'weapon_emp_nf_seismic_grenade',
	15: 'weapon_emp_nf_smoke_grenade',
	16: 'weapon_emp_nf_mortar',
	17: 'weapon_emp_nf_engineer_kit',
	18: 'weapon_emp_nf_binoculars',
	19: 'weapon_emp_imp_pistol1',
	20: 'weapon_emp_imp_pistol2',
	21: 'weapon_emp_imp_smg1',
	22: 'weapon_emp_imp_smg2',
	23: 'weapon_emp_imp_rifle1',
	24: 'weapon_emp_imp_rifle2',
	25: 'weapon_emp_imp_rifle3',
	26: 'weapon_emp_imp_hmg',
	27: 'weapon_emp_imp_explosive_grenade',
	28: 'weapon_emp_imp_concussion_grenade',
	29: 'weapon_emp_imp_seismic_grenade',
	30: 'weapon_emp_imp_smoke_grenade',
	31: 'weapon_emp_imp_mortar',
	32: None,
	33: 'weapon_emp_nf_mine_grenade',
	62: 'weapon_emp_imp_engineer_kit',
	63: 'weapon_emp_imp_binoculars',
	64: None,
	65: 'weapon_emp_imp_mine_grenade',
	66: 'weapon_emp_imp_rpg',
	67: 'weapon_emp_nf_sticky_grenade',
	68: 'weapon_emp_imp_sticky_grenade',
	69: 'weapon_emp_nf_sticky_stun_grenade',
	70: 'weapon_emp_imp_sticky_stun_grenade',
	}
	
	descdata = []
	
	classdata = ['Scout',
	'Rifleman',
	'Grenadier',
	'Engineer',
	'Unknown',
	'None']
	
	squaddata = [None,
	'Alpha',
	'Beta',
	'Charlie',
	'Delta',
	'Echo',
	'Foxtrott',
	'Golf',
	'Hotel',
	'India',
	'Juliet',
	'Kilo',
	'Lima',
	'Mike',
	'November',
	'Oscar',
	'Papa',
	'Quebec',
	'Romeo',
	'Sierra',
	'Tango',
	'Uniform',
	'Victor',
	'Whiskey',
	'X-Ray'
	'Yankee',
	'Zulu']
	
	# # # # # # # # # #
	# Private functions #
	# # # # # # # # # #
	def __init__(self,userid):
		if type(userid) == str and userid.isdigit():
			userid = int(userid)
		elif type(userid) not in [int,float,long]:
			raise InputError, 'Wrong input type. Input type has to be a integer, float or long.\nInput type was: %s' % type(userid)
		self.userid = userid
		if plugindata['player']:
			# Set vars for game entities - since the server slot number won't change these won't either.
			self.manager['player'] = es.getentityindex("player_manager")
			self.manager['player_nf'] = es.getentityindex("player_manager_nf")
			self.manager['player_imp'] = es.getentityindex("player_manager_imp")
			# Required for __GetPlayerIndex
			es.set('__empapi_index',0)
			# Required for __GetTime
			es.set('__empapi_time',0)
			# Load the descriptions for the skills and weapons dynamically from the script file
			kv = keyvalues.KeyValues(filename='%s/scripts/emp_descriptions.txt' % es.getString('eventscripts_gamedir'))
			for key in kv:
				self.descdata.append([key.getName(), 
				{'WeaponText': kv[key.getName()]['WeaponText'],
				'WeaponDescription': kv[key.getName()]['WeaponDescription'],
				'WeaponBackground': kv[key.getName()]['WeaponBackground'],}
				])
			# Dict/Attr Support
			# Get Items
			self.getitems['health'] = self.GetHealth
			self.getitems['endurance'] = self.GetEndurance
			self.getitems['class'] = self.GetClass
			self.getitems['classindex'] = self.GetClassIndex
			self.getitems['iscommander'] = self.IsCommander
			self.getitems['isincommanderinterface'] = self.IsInCommanderInterface
			self.getitems['squad'] = self.GetSquad
			self.getitems['issquadleader'] = self.IsSquadLeader
			self.getitems['isinlockedsquad'] = self.IsInLockedSquad
			self.getitems['tank'] = self.GetTank
			self.getitems['dead'] = self.IsDead
			self.getitems['isdead'] = self.IsDead
			self.getitems['prone'] = self.IsProne
			self.getitems['isprone'] = self.IsProne
			self.getitems['proning'] = self.IsProning
			self.getitems['isproning'] = self.IsProning
			self.getitems['ducked'] = self.IsDucked
			self.getitems['isducked'] = self.IsDucked
			self.getitems['ducking'] = self.IsDucking
			self.getitems['isducking'] = self.IsDucking
			self.getitems['duckjumping'] = self.IsDuckJumping
			self.getitems['isduckjumping'] = self.IsDuckJumping
			self.getitems['pronetime'] = self.GetProneTime
			self.getitems['ducktime'] = self.GetDuckTime
			self.getitems['duckjumptime'] = self.GetDuckJumpTime
			self.getitems['jumptime'] = self.GetJumpTime
			self.getitems['velocity'] = self.GetVelocity
			self.getitems['friction'] = self.GetFriction
			self.getitems['invisibility'] = self.GetInvisibility
			self.getitems['hashealthupgrade'] = self.HasHealthUpgrade
			self.getitems['healthupgrade'] = self.HasHealthUpgrade
			self.getitems['cappoint'] = self.GetCapPoint
			# ammo - finish
			self.getitems['ammo'] = self.GetAmmo
			#
			self.getitems['isprimarydesired'] = self.IsPrimaryDesired
			self.getitems['issecondarydesired'] = self.IsSecondaryDesired
			self.getitems['isgrenadedesired'] = self.IsGrenadeDesired
			self.getitems['isequipmentdesired'] = self.IsEquipmentDesired
			self.getitems['primary'] = self.GetPrimary
			self.getitems['secondary'] = self.GetSecondary
			self.getitems['grenade'] = self.GetGrenade
			self.getitems['equipment'] = self.GetEquipment
			self.getitems['primaryentityname'] = self.GetPrimaryEntityName
			self.getitems['secondarydentityname'] = self.GetSecondaryEntityName
			self.getitems['grenadeentityname'] = self.GetGrenadeEntityName
			self.getitems['equipmententityname'] = self.GetEquipmentEntityName
			self.getitems['isskill1desired'] = self.IsSkill1Desired
			self.getitems['isskill2desired'] = self.IsSkill2Desired
			self.getitems['isskill3desired'] = self.IsSkill3Desired
			self.getitems['isskill4desired'] = self.IsSkill4Desired
			self.getitems['skill1'] = self.GetSkill1
			self.getitems['skill2'] = self.GetSkill2
			self.getitems['skill3'] = self.GetSkill3
			self.getitems['skill4'] = self.GetSkill4
			self.getitems['mines'] = self.GetNumMines
			self.getitems['nummines'] = self.GetNumMines
			self.getitems['walls'] = self.GetWallsBuilt
			self.getitems['wallsbuilt'] = self.GetWallsBuilt
			self.getitems['wallsallotted'] = self.GetWallsAllotted
			self.getitems['turrets'] = self.GetTurretsBuilt
			self.getitems['turretsbuilt'] = self.GetTurretsBuilt
			self.getitems['turretsallotted'] = self.GetTurretsAllotted
			self.getitems['detection'] = self.GetDetectionBuilt
			self.getitems['detectionbuilt'] = self.GetDetectionBuilt
			self.getitems['detectionallotted'] = self.GetDetectionAllotted
			self.getitems['cameras'] = self.GetDetectionBuilt
			self.getitems['camerasbuilt'] = self.GetDetectionBuilt
			self.getitems['camerasallotted'] = self.GetDetectionAllotted
			self.getitems['nextsupply'] = self.GetNextSupply
			self.getitems['candropsupply'] = self.CanDropSupply
			self.getitems['restrict'] = self.GetRestrict
			self.getitems['turretrestrict'] = self.GetTurretRestrict
			self.getitems['turret1health'] = self.GetTurret1Health
			self.getitems['turrer2health'] = self.GetTurret2Health
			self.getitems['detection1health'] = self.GetDetection1Health
			self.getitems['detection2health'] = self.GetDetection2Health
			self.getitems['camera1health'] = self.GetDetection1Health
			self.getitems['camera2health'] = self.GetDetection2Health
			self.getitems['squadexp'] = self.GetSquadExp
			self.getitems['squadexperience'] = self.GetSquadExp
			self.getitems['squadxp'] = self.GetSquadExp
			self.getitems['squadexperiencepoints'] = self.GetSquadExp
			self.getitems['squadpoints'] = self.GetSquadExp
			self.getitems['hasloadedrpg'] = self.HasLoadedRPG
			self.getitems['loadedrpg'] = self.HasLoadedRPG
			self.getitems['hasloadedmortar'] = self.HasLoadedMortar
			self.getitems['loadedmortar'] = self.HasLoadedMortar
			# finnish following stuff
			self.getitems['isinvitedtosquad'] = self.IsInvitedToSquad
			self.getitems['squadleaderauraskill'] = self.GetSquadLeaderAuraSkill
			self.getitems['squadleaderpower'] = self.GetSquadLeaderPower
			self.getitems['squadleaderpowertime'] = self.GetSquadLeaderPowerTime
			# 
			self.getitems['score'] = self.GetScore
			self.getitems['points'] = self.GetPoints
			self.getitems['ping'] = self.GetPing
			self.getitems['latency'] = self.GetLatency
			self.getitems['frags'] = self.GetFrags
			self.getitems['kills'] = self.GetKills
			self.getitems['deaths'] = self.GetDeaths
			#Set Items
			self.setitems['health'] = self.SetHealth
			self.setitems['endurance'] = self.SetEndurance
			self.setitems['class'] = self.SetClass
			# ammo needs to be finished
			self.setitems['ammo'] = self.SetAmmo
			#
			self.setitems['walls'] = self.SetWallsBuilt
			self.setitems['wallsbuilt'] = self.SetWallsBuilt
			self.setitems['wallsallotted'] = self.SetWallsAllotted
			self.setitems['turrets'] = self.SetTurretsBuilt
			self.setitems['turretsbuilt'] = self.SetTurretsBuilt
			self.setitems['turretsallotted'] = self.SetTurretsAllotted
			self.setitems['detection'] = self.SetDetectionBuilt
			self.setitems['detectionbuilt'] = self.SetDetectionBuilt
			self.setitems['detectionallotted'] = self.SetDetectionAllotted
			self.setitems['cameras'] = self.SetDetectionBuilt
			self.setitems['camerasbuilt'] = self.SetDetectionBuilt
			self.setitems['camerasallotted'] = self.SetDetectionAllotted
			self.setitems['nextsupply'] = self.SetNextSupply
			self.setitems['addnextsupply'] = self.AddNextSupply
			self.setitems['removenextsupply'] = self.RemoveNextSupply
			self.setitems['restrict'] = self.SetRestrict
			self.setitems['turretrestrict'] = self.SetTurretRestrict
			self.setitems['hasloadedrpg'] = self.SetLoadedRPGState
			self.setitems['loadedrpg'] = self.SetLoadedRPGState
			self.setitems['hasloadedmortar'] = self.SetLoadedMortarState
			self.setitems['loadedmortar'] = self.SetLoadedMortarState
			# Set data to false:
			plugindata['player'] = False
	def __GetPlayerIndex(self):
		es.server.cmd('getplayerinfo __empapi_index %s index' % self.userid)
		return es.getString('__empapi_index').zfill(2)
	def __GetTime(self):
		es.server.cmd('getplayerinfo __empapi_time %s timeconnected' % self.userid)
		return es.getString('__empapi_time')
	def __Desc(self,id):
		return None if id == -1 else self.descdata[id][1]['WeaponText']
	# # # # # # # # #
	# Public functions #
	# # # # # # # # #
	def GetHealth(self):
		'''
		Returns the current amount of health.
		'''
		return es.getplayerprop(self.userid,"CBasePlayer.m_iHealth")
	def SetHealth(self,amount):
		'''
		Sets the health of the specific player to amount.
		'''
		es.setplayerprop(self.userid,"CBasePlayer.m_iHealth",amount)
	def GetEndurance(self):
		'''
		Retrieves the amount of sprint endurance.
		'''
		return es.getplayerprop(self.userid,"CSDKPlayer.localspecdata.m_flSprintAmount")
	def SetEndurance(self,amount):
		'''
		Sets the amount of sprint endurance. Value must be in range of 0-100.
		'''
		if not (0 <= amount <= 100):
			raise InputError, 'The amount is either too large or too small. Amount has to be in range of 0 to 100.\nInput was: %s' % amount
		es.setplayerprop(self.userid,"CSDKPlayer.localspecdata.m_flSprintAmount",amount)
	def GetClass(self):
		'''
		Returns the classname.
		'''
		return self.classdata[self.GetClassIndex()]
	def GetClassIndex(self):
		'''
		Returns the index of the classname.
		'''
		return es.getplayerprop(self.userid,"CSDKPlayer.m_iEmpClass")
	def SetClass(self,classname,change=True):
		'''
		Sets the class of a player. If change is set to false only the class will be changed, but not the model nor the weapons.
		If change is set to true the player will be given the default weapons.
		'''
		#DEVNOTE: change needs to be checked in detail. Skills need to be changed/reset when chaning class. Will stuff like hide be affected? Needs further investigation.
		if classname not in self.classdata:
			raise InputError, 'Invalid classname. Valid classnames are %s.\nInput was: %s' % (self.classdata,classname)
		es.setplayerprop(self.userid,"CSDKPlayer.m_iEmpClass",self.classdata[classname])
		if change:
			# Remove player equipment
			es.give(self.userid,'player_weaponstrip')
			es.fire(self.userid,'player_weaponstrip','Strip')
			es.fire(self.userid,'player_weaponstrip','Kill')
			# Get player team (to determine weaponary)
			team = es.getplayerteam(userid)
			# Give them weapons and set their model
			player = playerlib.getPlayer(userid)
			if team == 2:
				es.give(self.userid,'weapon_emp_nf_pistol')
				player.set('model','models\nf\characters\id\nf_soldier_%s' % random.choice(('kant','nort','tenn')))
				if classname == "Scout":
					es.give(self.userid,'weapon_emp_nf_smg1')
					es.give(self.userid,'weapon_emp_nf_binoculars')
					es.give(self.userid,'weapon_emp_nf_smoke_grenade')
				elif classname == "Rifleman":
					es.give(self.userid,'weapon_emp_nf_rifle')
					es.give(self.userid,'weapon_emp_nf_explosive_grenade')
				elif classname == "Grenadier":
					es.give(self.userid,'weapon_emp_nf_rpg')
					es.give(self.userid,'weapon_emp_nf_mortar')
					es.give(self.userid,'weapon_emp_nf_smoke_grenade')
				elif classname == "Engineer":
					es.give(self.userid,'weapon_emp_nf_smg1')
					es.give(self.userid,'weapon_emp_nf_engineer_kit')
					es.give(self.userid,'weapon_emp_nf_seismic_grenade')
			elif team == 3:
				es.give(self.userid,'weapon_emp_imp_pistol1')
				player.set('model','models\imperial\characters\id\imp_soldier_%s' % random.choice(('bohm','ed','sett')))
				if classname == "Scout":
					es.give(self.userid,'weapon_emp_imp_smg1')
					es.give(self.userid,'weapon_emp_imp_binoculars')
					es.give(self.userid,'weapon_emp_imp_smoke_grenade')
				elif classname == "Rifleman":
					es.give(self.userid,'weapon_emp_imp_rifle1')
					es.give(self.userid,'weapon_emp_imp_explosive_grenade')
				elif classname == "Grenadier":
					es.give(self.userid,'weapon_emp_imp_rpg')
					es.give(self.userid,'weapon_emp_imp_mortar')
					es.give(self.userid,'weapon_emp_imp_smoke_grenade')
				elif classname == "Engineer":
					# Engineer has an extra model...
					player.set('model','models\imperial\characters\engineer\imp_engineer_%s' % random.choice(('bohm','ed','sett')))
					es.give(self.userid,'weapon_emp_imp_smg1')
					es.give(self.userid,'weapon_emp_imp_engineer_kit')
					es.give(self.userid,'weapon_emp_imp_seismic_grenade')
	def IsCommander(self):
		'''
		Will Return true if the player is the commander.
		'''
		return __bool(es.getplayerprop(self.userid,"CSDKPlayer.m_bCommander"))
	def IsInCommanderInterface(self):
		'''
		Returns True if the player is in the commander interface.
		'''
		return __bool(es.getplayerprop(self.userid,"CSDKPlayer.m_bInCommanderInterface"))
	def GetSquad(self):
		'''
		Returns the name of the squad the player is in.
		Returns None if the player does not have a squad.
		'''
		return self.squaddata.index(es.getindexprop(self.manager['player'],"CPlayerResource.m_iSquad.0%s" % self.__GetPlayerIndex()))
	# Note: Setting Squad not possible.
	def IsSquadLeader(self):
		'''
		Returns True if the specified player is a squadleader.
		'''
		return __bool(es.getindexprop(self.manager['player'],"CPlayerResource.m_bSquadLeader.0%s" % self.__GetPlayerIndex()))
	def IsInLockedSquad(self):
		'''
		Returns True if the specified player is in a locked squad.
		'''
		return __bool(es.getindexprop(self.manager['player'],"CPlayerResource.m_bSquadLocked.0%s" % self.__GetPlayerIndex()))
	# Note: (Un-)Locking squads not possible
	def GetTank(self):
		team = es.getplayerteam(self.userid)
		if team == 3:
			index = self.manager['player_nf']
			tid = 'IMP'
		elif team == 2:
			index = self.manager['player_imp']
			tid = 'NF'
		else:
			return None
		return es.getindexprop(index,'CPlayerResource_%s.m_iVehicle_%s.0%s' % (tid, tid, self.__GetPlayerIndex()))
	# New stuff below
	def IsDead(self):
		'''
		Returns True if the player is dead.
		'''
		return __bool(es.getplayerprop(self.userid,'CBasePlayer.pl.deadflag'))
	def IsProne(self):
		'''
		Returns True if the player is prone.
		'''
		return __bool(es.getplayerprop(self.userid,'CBasePlayer.localdata.m_Local.m_bProne'))
	def IsProning(self):
		'''
		Returns True if the player is trying to prone.
		'''
		return __bool(es.getplayerprop(self.userid,'CBasePlayer.localdata.m_Local.m_bProning'))
	def IsDucked(self):
		'''
		Returns True if the player is ducked.
		'''
		return __bool(es.getplayerprop(self.userid,'CBasePlayer.localdata.m_Local.m_bDucked'))
	def IsDucking(self):
		'''
		Returns True if the player is trying to duck.
		'''
		return __bool(es.getplayerprop(self.userid,'CBasePlayer.localdata.m_Local.m_bDucking'))
	def IsDuckJumping(self):
		'''
		Returns True if the player is duck jumping.
		'''
		return __bool(es.getplayerprop(self.userid,'CBasePlayer.localdata.m_Local.m_bDuckJump'))
	def GetProneTime(self):
		'''
		Returns the remaing time required to prone/stand up.
		'''
		return es.getplayerprop(self.userid,'CBasePlayer.localdata.m_Local.m_flPronetime')
	def GetDuckTime(self):
		'''
		Returns the remaing time required to duck/stand up.
		'''
		return es.getplayerprop(self.userid,'CBasePlayer.localdata.m_Local.m_flDucktime')
	def GetDuckJumpTime(self):
		'''
		Returns the duckjumptime (?).
		'''
		return es.getplayerprop(self.userid,'CBasePlayer.localdata.m_Local.m_flDuckJumpTime')
	def GetJumpTime(self):
		'''
		Returns the jumptime (?).
		'''
		return es.getplayerprop(self.userid,'CBasePlayer.localdata.m_Local.m_flJumpTime')
	def GetVelocity(self):
		'''
		Returns the velocity.
		'''
		return es.getplayerprop(self.userid,'CBasePlayer.localdata.m_Local.m_flFallVelocity')
	def GetFriction(self):
		'''
		Returns current friction of the surface the player is standing on.
		'''
		return es.getplayerprop(self.userid,'CBasePlayer.localdata.m_flFriction')
	def GetInvisibility(self):
		'''
		Returns the current amount of invisibles. 
		This equals to the sides which the scout touches.
		'''
		return es.getplayerprop(self.userid,'CSDKPlayer.m_iInvisible')
	def HasHealthUpgrade(self):
		'''
		Returns True if the player has health upgrade skill.
		'''
		return __bool(es.getplayerprop(self.userid,'CSDKPlayer.m_bHealthUpgrade'))
	def GetCapPoint(self):
		'''
		Returns the entity index of the current cap point being contested/captured/defended.
		Returns 0 if player is not in a capture zone.
		'''
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iCapPointIndex')
	def GetAmmo(self):
		'''
		001 Melee
		002 Seismic, Explosive, Smoke, Concussion, Mines
		003 RPG 
		004 Pistol1
		005 SMG1, BE MachinePistol
		006 BE rifles, SMG 2, Scout Rifle
		007 NF .50 cal
		008 NF HMG
		009 Moartar
		016 NF Shotty Pistol
		017 Stickies
		'''
		pass
	def SetAmmo(self):
		pass
	def IsPrimaryDesired(self):
		'''
		Returns True if the player wants to change his primary weapon.
		'''
		return __bool(es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_bPrimaryWeaponDesired'))
	def IsSecondaryDesired(self):
		'''
		Returns True if the player wants to change his secondary weapon.
		'''
		return __bool(es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_bSidearmWeaponDesired'))
	def IsGrenadeDesired(self):
		'''
		Returns True if the player wants to change his grenade.
		'''
		return __bool(es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_bGrenadeDesired'))
	def IsEquipmentDesired(self):
		'''
		Returns True if the player wants to change his equipment item.
		'''
		return __bool(es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_bEquipmentDesired'))
	def GetPrimary(self):
		'''
		Returns the internal name of the primary weapon.
		'''
		return self.descdata[es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iPrimaryWeapon')][0]
	def GetSecondary(self):
		'''
		Returns the internal name of the secondary weapon.
		'''
		return self.descdata[es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iSidearmWeapon')][0]
	def GetGrenade(self):
		'''
		Returns the internal name of the granade.
		'''
		return self.descdata[es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iGrenade')][0]
	def GetEquipment(self):
		'''
		Returns the internal name of the equipment item.
		'''
		return self.descdata[es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iEquipment')][0]
	def GetPrimaryEntityName(self):
		'''
		Returns the entity name of the primary weapon.
		'''
		return self.weaponentitydata[es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iPrimaryWeapon')]
	def GetSecondaryEntityName(self):
		'''
		Returns the entity name of the scondary weapon.
		'''
		return self.weaponentitydata[es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iSidearmWeapon')]
	def GetGrenadeEntityName(self):
		'''
		Returns the entity name of the grenade.
		'''
		return self.weaponentitydata[es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iGrenade')]
	def GetEquipmentEntityName(self):
		'''
		Returns the entity name of the equipment item.
		Returns None if the equipment item is armor.
		'''
		return self.weaponentitydata[es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iEquipment')]
	def IsSkill1Desired(self):
		'''
		Returns True if the player wants to change this first skill.
		'''
		return __bool(es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_bSkill1Desired'))
	def IsSkill2Desired(self):
		'''
		Returns True if the player wants to change this second skill.
		'''
		return __bool(es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_bSkill2Desired'))
	def IsSkill3Desired(self):
		'''
		Returns True if the player wants to change this third skill.
		'''
		return __bool(es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_bSkill3Desired'))
	def IsSkill4Desired(self):
		'''
		Returns True if the player wants to change this fourth skill.
		'''
		return __bool(es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_bSkill4Desired'))
	def GetSkill1(self):
		'''
		Returns the name of the first player skill.
		Returns None if the skill is locked.
		'''
		return self.__Desc(es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iSkill1'))
	def GetSkill2(self):
		'''
		Returns the name of the second player skill.
		Returns None if the skill is locked.
		'''
		return self.__Desc(es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iSkill2'))
	def GetSkill3(self):
		'''
		Returns the name of the third player skill.
		Returns None if the skill is locked.
		'''
		return self.__Desc(es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iSkill3'))
	def GetSkill4(self):
		'''
		Returns the name of the fourth player skill.
		Returns None if the skill is locked.
		'''
		return self.__Desc(es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iSkill4'))
	def GetNumMines(self):
		'''
		Returns the current amount of mines has placed.
		'''
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iNumMines')
	# Get Built Item? - No idea what it is though
	def GetWallsBuilt(self):
		'''
		Returns the current amount of walls the player has built.
		'''
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iEngineerWallsBuilt')
	def SetWallsBuilt(self,amount):
		'''
		Sets the current amount of walls the player has built.
		Note: This will not destroy walls; it only sets the visible amount.
		'''
		es.setplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iEngineerWallsBuilt',amount)
	def GetWallsAllotted(self):
		'''
		Returns the current amount of walls the player is allowed to build.
		'''
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iEngineerWallsAllotted')
	def SetWallsAllotted(self,amount):
		'''
		Sets the current amount of walls the player is allowed to build.
		'''
		es.setplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iEngineerWallsAllotted',amount)
	def GetTurretsBuilt(self):
		'''
		Returns the current amount of turrets the player has built.
		'''
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iEngineerTurretsBuilt')
	def SetTurretsBuilt(self,amount):
		'''
		Sets the current amount of turrets the player has built.
		Note: This will not destroy turrets; it only sets the visible amount.
		'''
		es.setplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iEngineerTurretsBuilt',amount)
	def GetTurretsAllotted(self):
		'''
		Returns the current amount of turrets the player is allowed to build.
		'''
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iEngineerTurretsAllotted')
	def SetTurretsAllotted(self,amount):
		'''
		Sets the current amount of turrets the player is allowed to build.
		'''
		es.setplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iEngineerTurretsAllotted',amount)
	def GetDetectionBuilt(self):
		'''
		Returns the current amount of detection buildings the player has built.
		'''
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iEngineerDetectionBuilt')
	def GetCamerasBuilt(self):
		'''
		Returns the current amount of detection buildings the player has built.
		'''
		return self.GetDetectionBuilt()
	def SetDetectionBuilt(self,amount):
		'''
		Sets the current amount of detection buildings the player has built.
		Note: This will not destroy dectection buildings; it only sets the visible amount.
		'''
		es.setplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iEngineerDetectionBuilt',amount)
	def SetCamerasBuilt(self,amount):
		'''
		Sets the current amount of detection buildings the player has built.
		Note: This will not destroy dectection buildings; it only sets the visible amount.
		'''
		self.SetDetectionBuilt(amount)
	def GetDetectionAllotted(self):
		'''
		Returns the current amount of detection buildings the player is allowed to build.
		'''
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iEngineerDetectionAllotted')
	def GetCamerasBuilt(self):
		'''
		Returns the current amount of detection buildings the player is allowed to build.
		'''
		return self.GetDetecionAllotted()
	def SetDetectionAllotted(self,amount):
		'''
		Sets the current amount of detection buildings the player is allowed to build.
		'''
		es.setplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iEngineerDetectionAllotted',amount)
	def SetCamerasAllotted(self,amount):
		'''
		Sets the current amount of detection buildings the player is allowed to build.
		'''
		return self.SetDetecionAllotted(amount)
	def CanDropSupply(self):
		'''
		Returns True if the user can drop a supply create. 
		'''
		return True if self.GetNextSupply() <= 0 else False
	def GetNextSupply(self):
		'''
		Returns the time when the player was/will be allowed to drop the next supply crate.
		Note: Result can be neagtive.
		'''
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_flEngineerNextSupply') - self.__GetTime()
	def SetNextSupply(self,amount):
		'''
		Sets the time when the player is allowed to drop the next supply crate.
		
		Note: 
		This will override the value which might reduce the time until the player can drop the next crate.
		To prevent this AddNextSupply or RemoveNextSupply can be used.
		'''
		es.setplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_flEngineerNextSupply',self.__GetTime() + amount)
	def AddNextSupply(self,amount):
		'''
		Adds amount to the time when the player is allowed to drop the next supply crate.
		If the current amount of time the player has to wait is 0, it will set the amount instead.
		'''
		next = self.GetNextSupply()
		if next >= 0:
			amount += next
		self.SetNextSupply(self,amount)
	def RemoveNextSupply(self,amount):
		'''
		Removes amount from the time when the player is allowed to drop the next supply crate.
		'''
		self.SetNextSupply(self,amount - self.GetNextSupply())
	def GetRestrict(self):
		'''
		Returns the current engineer restrict level.
		
		0: Allow everything
		1: Allow everything but walls
		2: Don't allow engineer building
		'''
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iEngBuild')
	def SetRestrict(self,amount):
		'''
		Sets the current engineer restrict level.
		
		Level has to be inrange of 0-2:
		0: Allow everything
		1: Allow everything but walls
		2: Don't allow engineer building
		'''
		level = int(level)
		if 0 <= level <= 2:
			es.setplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iEngBuild',level)
		else:
			raise InputError, 'Level has to be inrange of 0-2\nLevel was: %i' % level
	def GetTurretRestrict(self):
		'''
		Returns the current turret restrict level.
		
		0: Don't allow turrets 
		1: Allow lvl 1 turrets
		2: Allow lvl 2 turrets
		3: Allow lvl 3 turrets
		'''
		return 3 - es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldatam_iTurretRestrict')
	def SetTurretRestrict(self,amount):
		'''
		Sets the current turret restrict level.
		
		Level has to be inrange of 0-3:
		0: Don't allow turrets 
		1: Allow lvl 1 turrets
		2: Allow lvl 2 turrets
		3: Allow lvl 3 turrets
		'''
		level = int(level)
		if 0 <= level <= 3:
			es.setplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iTurretRestrict',3 - level)
		else:
			raise InputError, 'Level has to be inrange of 0-3\nLevel was: %i' % level
	def GetTurret1Health(self):
		'''
		Returns the health points of the engineer's first turret.
		'''
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iTurretHealth')
	def GetTurret2Health(self):
		'''
		Returns the health points of the engineer's second turret.
		'''
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iTurretHealth2')
	def GetDetection1Health(self):
		'''
		Returns the health points of the engineer's first detection building.
		'''
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iCameraHealth')
	def GetDetection2Health(self):
		'''
		Returns the health points of the engineer's second detection building.
		'''
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iCameraHealth2')
	def GetCamera1Health(self):
		'''
		Returns the health points of the engineer's first detection building.
		'''
		return self.GetDetection1Health()
	def GetCamera2Health(self):
		'''
		Returns the health points of the engineer's second detection building.
		'''
		return self.GetDetection2Health()
	def GetSquadExp(self):
		'''
		Returns the current amount of squad points in the player's squad.
		'''
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iEmpSquadXP')
	def HasLoadedRPG(self):
		'''
		Returns True if the player has his RPG loaded.
		'''
		return __bool(es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_bRPGLoaded'))
	def SetLoadedRPGState(self,state):
		'''
		Sets whether the player has his RPG loaded.
		This will not stop the loading animation.
		'''
		es.setplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_bRPGLoaded',__BoolChk(state).var)
	def HasLoadedMortar(self):
		'''
		Returns True if the player has his mortar loaded.
		'''
		return __bool(es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_bMortarLoaded'))
	def SetLoadedMortarState(self,state):
		'''
		Sets whether the player has his RPG loaded.
		This will not stop the loading animation.
		'''
		es.setplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_bMortarLoaded',__BoolChk(state).var)
	# Functions below need to be finshed/checked
	def IsInvitedToSquad(self):
		'''
		Returns True if the player has been invited to squad.
		'''
		return __bool(es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_bInvitedToSquad'))
	def GetSquadLeaderAuraSkill(self):
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iSquadLeaderAuraSkill')
	def GetSquadLeaderPower(self):
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iSquadLeaderPower')
	def GetSquadLeaderPowerTime(self):
		return es.getplayerprop(self.userid,'CSDKPlayer.sdklocaldata.m_iSquadLeaderPowerTime')
	def GetScore(self):
		'''
		Returns the player's current score.
		'''
		return es.getindexprop(self.player_manger_index,'CPlayerResource.m_iScore.0%s' % self.__GetPlayerIndex())
	def GetPoints(self):
		'''
		Returns the player's current score.
		'''
		return self.GetPoints()
	def GetPing(self):
		'''
		Returns the player's current ping.
		'''
		return es.getindexprop(self.player_manger_index,'CPlayerResource.m_iPing.0%s' % self.__GetPlayerIndex())
	def GetLatency(self):
		'''
		Returns the player's current score.
		'''
		return self.GetPing()
	def GetFrags(self):
		'''
		Returns the player's current frags.
		'''
		return es.getindexprop(self.player_manger_index,'CPlayerResource.m_iFrags.0%s' % self.__GetPlayerIndex())
	def GetKills(self):
		'''
		Returns the player's current score.
		'''
		return self.GetKills()
	def GetDeaths(self):
		'''
		Returns the player's current kills.
		'''
		return es.getindexprop(self.player_manger_index,'CPlayerResource.m_iDeaths.0%s' % self.__GetPlayerIndex())
class tank(__entshared):
	'''
	Provides access to tank properties.
	'''
	# # # # #
	# DATA #
	# # # # #
	getitems = {}
	setitems = {}
	
	index = None
	
	chassisdata = ["NF Jeep",
	"NF APC",
	"NF Light Tank",
	"NF Light Tank MKII",
	"NF Med Tank",
	"NF Heavy Tank",
	"NF Arty Tank",
	"Imperial Jeep",
	"Imperial APC",
	"Imperial AFV",
	"Imperial AFV MKII",
	"Imperial Med Tank",
	"Imperial Heavy Tank",
	"Imperial Arty Tank",
	"Imperial Commander",
	"NF Commander"]
	
	sides = ['front',
	'back',
	'left',
	'right'] 
	
	def __init__(self,index):
		self.index = index
		if plugindata['tank']:
			# Dict/Attr Support
			super(tank,self).__init__()
			# Get Items
			self.getitems['health'] = self.GetHealth
			self.getitems['maxhealth'] = self.GetMaxHealth
			self.getitems['iscv'] = self.IsCV
			self.getitems['iscommandvehicle'] = self.IsCV
			self.getitems['heat'] = self.GetHeat
			self.getitems['cost'] = self.GetCost
			self.getitems['chassis'] = self.GetChassis
			#Set Items
			self.setitems['cvstate'] = self.SetCVState
			self.setitems['health'] = self.SetHealth
			self.setitems['maxhealth'] = self.SetMaxHealth
			self.setitems['heat'] = self.SetHeat
			self.setitems['cost'] = self.SetCost
			# Set data to false:
			plugindata['tank'] = False
	# # # # # # # # # #
	# Private functions #
	# # # # # # # # # #
	def __GetSide(self,side):
		side = side.lower()
		if side not in self.sides:
			raise InputError, 'Invalid side. Valid sides are %s.\nInput was: %s' % (self.sides,side)
		return sides.index(side)
	def __len(self,items,length=4,minlength=4):
		if minlength <= len(items) == length:
			return True
		else:
			raise InputError, 'Invalid amount of items in data object. Expected length is %s.\nLength was %s' % (length,len(items))
	# # # # # # # # #
	# Public functions #
	# # # # # # # # #
	def GetArmorPlates(self,side):
		'''
		Returns the amount of armor plates of the specified side.
		'''
		return es.getindexprop(self.index,"CEmpTank.m_iArmorInches.00%s" % __GetSide(side))
	def SetArmorPlates(self,side,amount):
		'''
		Set the amount of armor plates of the specified side.
		'''
		es.setindexprop(self.index,"CEmpTank.m_iArmorInches.00%s" % __GetSide(side),amount)
	def GetMaxArmorPlates(self,side):
		'''
		Returns the maximum amount of armor plates of the specified side.
		'''
		return es.getindexprop(self.index,"CEmpTank.m_iArmorInchesMax.00%s" % __GetSide(side))
	def SetMaxArmorPlates(self,side,amount):
		'''
		Set the maximum amount of armor plates of the specified side.
		'''
		es.setindexprop(self.index,"CEmpTank.m_iArmorInchesMax.00%s" % __GetSide(side),amount)
	def GetArmor(self,side):
		'''
		Returns the amount of armor points.
		'''
		return es.getindexprop(self.index,"CEmpTank.m_flVehicleArmor.00%s" % __GetSide(side))
	def SetArmor(self,side,amount):
		'''
		Sets the amount of armor points.
		'''
		es.setindexprop(self.index,"CEmpTank.m_flVehicleArmor.00%s" % __GetSide(side),amount)
	def GetHealth(self):
		'''
		Returns the vehicle hull health points.
		'''
		return es.getindexprop(self.index,"CEmpTank.m_flTotalHealth")
	def SetHealth(self,amount):
		'''
		Sets the vehicle hull health points.
		Note: Don't set this if the vehicle has full health points; the vehicle can't be repaired in that case until it has been damaged.
		Note 2: Don't set this higher than the max vehicle health.
		'''
		es.setindexprop(self.index,"CEmpTank.m_flTotalHealth",amount)
	def GetMaxHealth(self):
		'''
		Returns the maximum vehicle hull health points.
		'''
		return es.getindexprop(self.index,"CEmpTank.m_flMaxTotalHealth")
	def SetMaxHealth(self,amount):
		'''
		Sets the maximum vehicle hull health points.
		'''
		es.setindexprop(self.index,"CEmpTank.m_flMaxTotalHealth",amount)
	def GetArmorPerPlate(self):
		'''
		Returns the amount of armor per plate.
		'''
		return es.getindexprop(self.index,"CEmpTank.m_iMaxArmorHealth")
	def SetArmorPerPlate(self,amount):
		'''
		Sets the amount of armor per plate.
		'''
		es.setindexprop(self.index,"CEmpTank.m_iMaxArmorHealth",amount)
	def IsCV(self):
		'''
		Returns true if the specified vehicle is the command vehicle.
		'''
		return __bool(es.getindexprop(self.index,"CEmpTank.m_bCommandVehicle"))
	def IsCommandVehicle(self):
		'''
		Returns true if the specified vehicle is the command vehicle.
		'''
		self.IsCV()
	def SetCVState(self,state):
		'''
		Sets the commander state of a vehicle.
		0 = regular vehicle, 1 = commander.
		'''
		es.setindexprop(self.index,"CEmpTank.m_bCommandVehicle",__BoolChk(state).var)
	def SetCommandVehicleState(self,state):
		'''
		Sets the commander state of a vehicle.
		0 = regular vehicle, 1 = commander.
		'''
		self.SetCVState(state)
	def GetHeat(self):
		'''
		Returns the amount of vehicle heat.
		'''
		return es.getindexprop(self.index,"CEmpTank.tankpassengersdata.m_flVehicleHeat")
	def SetHeat(self,amount):
		'''
		Sets the amount of vehicle heat.
		Note: Amount must be inrage of 0-100.
		'''
		if not (0 < amount < 100):
			raise InputError, "Wrong Input value. Heat has to be inrange of 0-100.\nInput was: %s" % amount
		es.setindexprop(self.index,"CEmpTank.tankpassengersdata.m_flVehicleHeat",amount)
	def GetCost(self):
		'''
		Returns the vehicle cost.
		'''
		return es.getindexprop(self.index,"CEmpTank.tankpassengersdata.m_iTotalCost")
	def SetCost(self,amount):
		'''
		Sets the vehicle cost.
		Note: This applies to repair pads - set it higher and you'll get money back.
		'''
		es.setindexprop(self.index,"CEmpTank.tankpassengersdata.m_iTotalCost",amount)
	def GetChassis(self):
		'''
		Gets the Vehicle Chassis Name
		'''
		return self.chassisdata[es.getindexprop(self.index,"CEmpTank.m_iChassis")]
	"""
	This needs to be tested
	def SetChassis(self,chassis):
	"""
	# Homingwarning
	# Passanger
	def GetCannonIndex(self):
		pass
	def GetTurretIndex(self):
		pass
	class cannon(object):
		pass
	class turret(object):
		pass

class game(__shared):
	'''
	Provides access to non player related game internals such as resources or tickets.
	The team paramenter must be given in any case.
	'''
	# # # # #
	# DATA #
	# # # # #
	getitems = {}
	setitems = {}
	
	manager = {}

	team = None
	
	teamdata = {"nf": "NF",
	"be": "Imp",
	"imp": "Imp",
	"brenodi empire": "Imp",
	"northern faction": "NF",
	"3": "Imp",
	"2": "NF"}
	
	researchdata = []
	
	def __init__(self,team):
		team = str(team).lower()
		if team in self.teamdata:
			self.team = self.teamdata[team]
		else:
			raise InputError, "Wrong input. Input has to be one of the following: %s" % list(self.teamdata)
		if plugindata['game']:
			# Set vars for game entities - since the server slot number won't change these won't either.
			self.manager['player'] = es.getentityindex("player_manager")
			self.manager['research'] = es.getentityindex("research_manager")
			# Parse the data for research items.
			kv = keyvalues.KeyValues(filename='%s/scripts/research_items.txt' % es.getString('eventscripts_gamedir'))
			for key in kv:
				self.researchdata.append([key.getName(), 
				{'Name': kv[key.getName()]['Name'],
				'Parent': kv[key.getName()]['Parent'],
				'Description': kv[key.getName()]['Description'],
				'Icon': kv[key.getName()]['Icon'],
				'Unresearched Icon': kv[key.getName()]['Unresearched Icon'],
				'Type': kv[key.getName()]['Type'],
				'Cost': kv[key.getName()]['Cost'],
				'Time': kv[key.getName()]['Time'],
				'Team': kv[key.getName()]['Team']}
				])
			# Dict/Attr Support
			# Get Items
			self.getitems['cvindex'] = self.GetCVIndex
			self.getitems['commandvehicleindex'] = self.GetCVIndex
			self.getitems['res'] = self.GetRes
			self.getitems['reinf'] = self.GetReinf
			self.getitems['currentresearch'] = self.GetCurrentResearch
			self.getitems['currentresearchname'] = self.GetCurrentResearchName
			self.getitems['currentresearchtime'] = self.GetCurrentResearchTime
			self.getitems['hasradar'] = self.HasRadar
			self.getitems['aircraft'] = self.GetAircraftAmount
			self.getitems['vehicle'] = self.GetVehicleAmount
			self.getitems['player'] = self.GetPlayerAmount
			#Set Items
			self.setitems['research'] = self.SetResearch
			self.setitems['res'] = self.SetRes
			self.setitems['reinf'] = self.SetReinf
			self.setitems['giveres'] = self.SetRes
			self.setitems['givereinf'] = self.SetReinf
			self.setitems['takeres'] = self.SetRes
			self.setitems['takereinf'] = self.SetReinf
			# Set data to false:
			plugindata['game'] = False
	# # # # # # # # # #
	# Private functions #
	# # # # # # # # # #
	def __VerifyResearchItem(self,item):
		for listitem in self.researchdata:
			if listitem[1]['Name'] == item:
				itemid = str(self.researchdata.index(listitem))
				return itemid.zfill(2)
		raise InputError, "Wrong input. Research input was: %s\nTo retrive a list of valid inputs run empires_api.PrintResearchData()!" % item
	def __GetTeamClassIndex(self):
		return player_manager_nf_index if self.team == "NF" else player_manager_imp_index
	def __GetRandomUserid(self):
		ids = es.getUseridList()
		if len(ids) > 0:
			return random.choice(ids)
		else:
			raise UseridError, "This function can not be used when the server is empty."
	def __Res(self,amount):
		es.fire(self.__GetRandomUserid(),"emp_info_params","AddOutput","%sRes %s" % (self.team,amount))
	def __Reinf(self,amount):
		es.fire(self.__GetRandomUserid(),"emp_info_params","AddOutput","%sReinf %s" % (self.team,amount + 1))
	# # # # # # # # #
	# Public functions #
	# # # # # # # # #
	# Resource functions
	def SetRes(self,amount):
		'''
		Sets the team resources to the specified amount.
		'''
		self.__Res(amount)
	def TakeRes(self,amount):
		'''
		Removes the specified amount from the team resources.
		'''
		self.__Res(self.GetRes() - amount)
	def GiveRes(self,amount):
		'''
		Adds the specified amount from the team resources.
		'''
		self.__Res(self.GetRes() + amount)
	def GetRes(self):
		'''
		Returns the team resources.
		'''
		return es.getindexprop(self.__GetTeamClassIndex(),"CPlayerResource_%s.m_iResources" % self.team.upper())
	# Ticket (Reinforcement) functions
	def SetReinf(self,amount):
		'''
		Sets the team tickets to the specified amount.
		'''
		self.__Reinf(amount)
	def TakeReinf(self,amount):
		'''
		Removes the specified amount from the team tickets.
		'''
		self.__Reinf(self.GetReinf() - amount)
	def GiveReinf(self,amount):
		'''
		Adds the specified amount from the team tickets.
		'''
		self.__Reinf(self.GetReinf() + amount)
	def GetReinf(self):
		'''
		Returns the team tickets.
		'''
		return es.getindexprop(self.manager['player'],"CPlayerResource.m_i%sReinforcements" % self.team) - 1
	# Research
	def IsResearched(self,item):
		'''
		Returns True if the specified item is researched, False otherwise.
		'''
		item = self.__VerifyResearchItem(item)
		return __bool(es.getindexprop(self.manager['research'],"CResearchResource.m_bResearched_%s.0%s" % (self.team.upper(), item)))
		# # # DEVNOTE: CHECK THIS ###
	def SetResearch(self,item):
		'''
		Researches the specified item.
		'''
		es.setindexprop(self.manager['research'],"CResearchResource.m_bResearched_%s.0%s" % (self.team.upper(), self.__VerifyResearchItem(item)),1)
	def GetCurrentResearch(self):
		'''
		Returns the name and remaining research time of the item currently being researched.
		Returns None if nothing is being researched.
		'''
		return self.GetCurrentResearchName(),self.GetCurrentResearchTime()
	def GetCurrentResearchName(self):
		'''
		Returns the name of the item currently being researched.
		Returns None if nothing is being researched.
		'''
		item = es.getindexprop(self.manager['research'],"CResearchResource.m_iResearchItem_%s" % self.team.upper())
		if item:
			return self.researchdata[item][1]['Name']
		return False
	def GetCurrentResearchTime(self):
		'''
		Returns the remaining research time of the item currently being researched.
		Returns None if nothing is being researched.
		'''
		return es.getindexprop(self.manager['research'],"CResearchResource.m_iResearchTime_%s" % self.team.upper())
	def HasRadar(self):
		'''
		Returns True if the team has at least one Radar, False otherwise.
		'''
		return __bool(es.getindexprop(self.manager['research'],"CResearchResource.m_bRadarBuilt_%s" % self.team.upper()))
	# Misc Functions
	def GetPlayerAmount(self):
		'''
		Returns the amount of players in the previously specified team.
		'''
		return es.getindexprop(self.__GetTeamClassIndex(),"CPlayerResource_%s.m_iPlayers" % self.team.upper())
	def GetVehicleAmount(self):
		'''
		Returns the amount of vehicles in the previously specified team.
		'''
		return es.getindexprop(self.__GetTeamClassIndex(),"CPlayerResource_%s.m_iPlayers" % self.team.upper())
	def GetAircraftAmount(self):
		'''
		Returns the amount of aircraft in the previously specified team.
		'''
		return es.getindexprop(self.__GetTeamClassIndex(),"CPlayerResource_%s.m_iPlayers" % self.team.upper())
	def GetCVIndex(self):
		'''
		Returns the entity index of the team's command vehicle.
		Returns -1 if there is no CV.
		'''
		return es.getentityindex("emp_%s_commander" % self.team.lower())
	def GetCommandVehicleIndex(self):
		'''
		Returns the entity index of the team's command vehicle.
		Returns -1 if there is no CV.
		'''
		return self.GetCVIndex()

# Checking Classes

class __BoolChk(object):
	var = None
	def __init__(self,var):
		self.var = var
		if type(self.var) == bool:
			self.Return()
		elif type(self.var) in [int,float,long]:
			self.Return()
		elif type(self.var) == str:
			if self.var.isdigit():
				self.Return()
			elif self.var.lower() == 'true':
				self.var == True
				self.Return()
			elif self.var.lower() == 'false':
				self.var == False
				self.Return()
			else:
				raise InputError,'Can not convert string. Input needs to be a bool or 0/1.\nInput was %s' % self.var
		else:
			raise InputError,'Unrecognised Input Type. Input needs to a bool or 0/1.\nInput was %s\nInput type was: %s' % (self.var,type(self.var))
	def Return(self):
		self.var = int(self.var)
		if not (self.var == 0 or self.var == 1):
			raise InputError,'Wrong Input value. The input needs to be a bool or 0/1.\nInput was: %s' % self.var

# Help /Support Class

class Help(object):
	'''
	Class for providing help.
	Page reprenets the amount of items from a list to display until continuing.
	
	WARNING: 
	Only set page to nonzero if you have direct access to the server console.
	It will halt the server until you pressed a key.
	'''
	page = 0
	
	def __init__(self,page=0):
		if page < 0:
			raise InputError,'Wrong Input. Pages must be greater then 0!\nInput was:%s' % page
		self.page = page
	# # # # # # # # # #
	# Private functions #
	# # # # # # # # # #
	def __InitChk(self,parm):
		if plugindata[parm] == True:
			raise InitError,'Class %s hasn\'t been initialised yet!' % parm
	def __PrintParsedList(self,list):
		id = 0
		for listitem in list:
			es.dbgmsg(0,'ID: %s' % id)
			es.dbgmsg(0,'GameID: %s' % listitem[0])
			for item in listitem[1]:
				es.dbgmsg(0,'%s: %s' % (item,listitem[1][item]))
			id += 1
			es.dbgmsg(0,' ')
			if self.page:
				if id % self.page == 0:
					raw_input('Press any key to continue!\n')
	# # # # # # # # #
	# Public functions #
	# # # # # # # # #
	def PrintResearchData(self):
		'''
		Prints all stored information about resarch items to the server console.
		'''
		self.__InitChk('game')
		self.__PrintParsedList(game.researchdata)
	def PrintWeaponData(self):
		'''
		Prints all stored information about weapons/skills to the server console.
		'''
		self.__InitChk('player')
		self.__PrintParsedList(player.descdata)
	def PrintSkillData(self):
		'''
		Prints all stored information about weapons/skills to the server console.
		'''
		self.PrintWeaponData()
	def Help(self,obj):
		'''
		Works like python's help function.
		
		WARNING: 
		Only use the Help function if you have direct access to the server console.
		It will halt the server until you pressed a key.
		'''
		try:
			pydoc.Helper(0,0).help(obj)
		# Ignore the stupid attribute error
		except AttributeError:
			pass
# # # # # #
# Functions #
# # # # # #

# Private

def __bool(var):
	# We can't use the internel bool function as any value is True. Sometimes the game returns 256 or similar values altough it's supposed to be false.
	return True if var & 1 else False
	
def __GetRandomUserid():
	ids = es.getUseridList()
	if len(ids) > 0:
		return random.choice(ids)
	else:
		raise UseridError, "This function can not be used when the server is empty."

# Public

def IsTeamChat(msg):
	'''
	This returns 1 if the message was team-chat only. Please keep in mind that this function does not provide a fail-safe check.
	'''
	if type(msg) == str:
		return True if msg[0] == '(' and msg[2].isdigit() and msg[3:5] == ') ' else False
	else:
		raise InputError,'Wrong input type. Input type has to be a string.\nInput type was: %s' % type(msg)
		
def SetMapTurretRestrict(level):
	'''
	Sets the current turret restrict level.
	This functions requires at least one active player to work.
	
	Level has to be inrange of 0-3:
	0: Don't allow turrets 
	1: Allow lvl 1 turrets
	2: Allow lvl 2 turrets
	3: Allow lvl 3 turrets
	'''
	level = int(level)
	if 0 <= level <= 3:
		# The way I use for the levels seems more logical to me, its different from emp one though
		es.fire(__GetRandomUserid(),'emp_info_params','AddOutput','turretRestrict %i' % (3 - level))
	else:
		raise InputError, 'Level has to be inrange of 0-3\nLevel was: %i' % level